Groovy Documentation

## org.codehaus.groovy.grails.commons
[Java] Class GrailsClassUtils

    java.lang.Object
      org.codehaus.groovy.grails.commons.GrailsClassUtils

    public class GrailsClassUtils

Utility methods for dealing with Grails class artifacts.

Authors:
  Graeme Rocher

Field Summary
`static java.util.Map` | `PRIMITIVE_TYPE_COMPATIBLE_CLASSES`

Method Summary
`static Object[]` | `collectionToObjectArray(java.util.Collection c)` Convenience method for converting a collection to an Object[]
`static java.util.Collection` | `createConcreteCollection(java.lang.Class interfaceType)` Creates a concrete collection for the suppied interface
`static java.lang.String` | `findPropertyNameForValue(java.lang.Object target, java.lang.Object obj)` Locates the name of a property for the given value on the target object using Groovy's meta APIs.
`static boolean` | `getBooleanFromMap(java.lang.String key, java.util.Map map)` Retrieves a boolean value from a Map for the given key
`static java.lang.String` | `getClassName(java.lang.String logicalName, java.lang.String trailingName)` Returns the class name for the given logical name and trailing name.
`static java.lang.String` | `getClassNameRepresentation(java.lang.String name)` Returns the class name representation of the given name
`static groovy.lang.MetaClass` | `getExpandoMetaClass(java.lang.Class clazz)`
`static java.lang.Object` | `getFieldValue(java.lang.Object obj, java.lang.String name)` Get the value of a declared field on an object
`static java.lang.String` | `getGetterName(java.lang.String propertyName)` Calculate the name for a getter method to retrieve the specified property
`static java.lang.String` | `getLogicalName(java.lang.Class clazz, java.lang.String trailingName)` Retrieves the logical class name of a Grails artifact given the Grails class and a specified trailing name
`static java.lang.String` | `getLogicalName(java.lang.String name, java.lang.String trailingName)` Retrieves the logical name of the class without the trailing name
`static java.lang.String` | `getLogicalPropertyName(java.lang.String className, java.lang.String trailingName)` @deprecated Use GrailsNameUtils.getLogicalPropertyName instead.
`static java.lang.String` | `getNameFromScript(java.lang.String scriptName)` Calculates the class name from a script name in the form my-funk-grails-script
`static java.lang.String` | `getNaturalName(java.lang.String name)` Converts a property name into its natural language equivalent eg ('firstName' becomes 'First Name')
`static PropertyDescriptor[]` | `getPropertiesAssignableToType(java.lang.Class clazz, java.lang.Class propertySuperType)` Retrieves all the properties of the given class which are assignable to the given type
`static PropertyDescriptor[]` | `getPropertiesOfType(java.lang.Class clazz, java.lang.Class propertyType)` Retrieves all the properties of the given class for the given type
`static java.beans.PropertyDescriptor` | `getProperty(java.lang.Class clazz, java.lang.String propertyName, java.lang.Class propertyType)` Retrieves a property of the given class of the specified name and type
`static java.beans.PropertyDescriptor` | `getPropertyDescriptorForValue(java.lang.Object instance, java.lang.Object propertyValue)` Retrieves a PropertyDescriptor for the specified instance and property value
`static java.lang.String` | `getPropertyForGetter(java.lang.String getterName)` Returns a property name equivalent for the given getter name or null if it is not a getter
`static java.lang.String` | `getPropertyForSetter(java.lang.String setterName)` Returns a property name equivalent for the given setter name or null if it is not a getter
`static java.lang.String` | `getPropertyName(java.lang.String name)` Shorter version of getPropertyNameRepresentation
`static java.lang.String` | `getPropertyName(java.lang.Class clazz)` Shorter version of getPropertyNameRepresentation
`static java.lang.String` | `getPropertyNameForLowerCaseHyphenSeparatedName(java.lang.String name)` Converts foo-bar into fooBar
`static java.lang.String` | `getPropertyNameRepresentation(java.lang.Class targetClass)` Returns the property name equivalent for the specified class
`static java.lang.String` | `getPropertyNameRepresentation(java.lang.String name)` Returns the property name representation of the given name
`static java.lang.Object` | `getPropertyOrStaticPropertyOrFieldValue(java.lang.Object obj, java.lang.String name)` Looks for a property of the reference instance with a given name.
`static java.lang.Class` | `getPropertyType(java.lang.Class clazz, java.lang.String propertyName)` Returns the type of the given property contained within the specified class
`static java.lang.Object` | `getPropertyValueOfNewInstance(java.lang.Class clazz, java.lang.String propertyName, java.lang.Class propertyType)` Returns the value of the specified property and type from an instance of the specified Grails class
`static java.lang.Object` | `getPropertyValueOfNewInstance(java.lang.Class clazz, java.lang.String propertyName)` Returns the value of the specified property and type from an instance of the specified Grails class
`static java.lang.String` | `getScriptName(java.lang.Class clazz)` Retrieves the script name representation of the supplied class.
`static java.lang.String` | `getScriptName(java.lang.String name)` @deprecated Use GrailsNameUtils.getScriptName instead.
`static java.lang.String` | `getSetterName(java.lang.String propertyName)` Retrieves the name of a setter for the specified property name
`static java.lang.String` | `getShortName(java.lang.Class targetClass)` Returns the class name without the package prefix
`static java.lang.String` | `getShortName(java.lang.String className)` Returns the class name without the package prefix
`static java.lang.Object` | `getStaticPropertyValue(java.lang.Class clazz, java.lang.String name)` Get a static property value, which has a public static getter or is just a public static field.
`static boolean` | `isAssignableOrConvertibleFrom(java.lang.Class clazz, java.lang.Class type)` Returns true if the specified clazz parameter is either the same as, or is a superclass or superinterface of, the specified type parameter.
`static boolean` | `isClassBelowPackage(java.lang.Class theClass, java.util.List packageList)` Returns whether the specified class is either within one of the specified packages or within a subpackage of one of the packages
`static boolean` | `isGetter(java.lang.String name, Class[] args)` Returns true if the name of the method specified and the number of arguments make it a javabean property
`static boolean` | `isGroovyAssignableFrom(java.lang.Class leftType, java.lang.Class rightType)` Tests whether or not the left hand type is compatible with the right hand type in Groovy terms, i.e. can the left type be assigned a value of the right hand type in Groovy.
`static boolean` | `isJdk5Enum(java.lang.Class type)` Checks whether the given class is a JDK 1.5 enum or not
`static boolean` | `isMatchBetweenPrimativeAndWrapperTypes(java.lang.Class leftType, java.lang.Class rightType)` Detect if left and right types are matching types.
`static boolean` | `isPropertyInherited(java.lang.Class clz, java.lang.String propertyName)` Checks whether the specified property is inherited from a super class
`static boolean` | `isPropertyOfType(java.lang.Class clazz, java.lang.String propertyName, java.lang.Class type)` Returns true if the specified property in the specified class is of the specified type
`static boolean` | `isPublicField(java.lang.Object obj, java.lang.String name)` Work out if the specified object has a public field with the name supplied.
`static boolean` | `isPublicStatic(java.lang.reflect.Method m)` Determine whether the method is declared public static
`static boolean` | `isPublicStatic(java.lang.reflect.Field f)` Determine whether the field is declared public static
`static boolean` | `isSetter(java.lang.String name, Class[] args)`
`static boolean` | `isStaticProperty(java.lang.Class clazz, java.lang.String propertyName)` Work out if the specified property is readable and static.

Methods inherited from class java.lang.Object
java.lang.Object#wait(), java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

Field Detail

### PRIMITIVE_TYPE_COMPATIBLE_CLASSES

    public static final java.util.Map PRIMITIVE_TYPE_COMPATIBLE_CLASSES

Method Detail

### collectionToObjectArray

    @SuppressWarnings({ "unchecked", "rawtypes" })
    public static Object[] collectionToObjectArray(java.util.Collection c)

  Convenience method for converting a collection to an Object[]
  Parameters:
    `c` - The collection
  Returns:
    An object array

### createConcreteCollection

    @SuppressWarnings("rawtypes")
    public static java.util.Collection createConcreteCollection(java.lang.Class interfaceType)

  Creates a concrete collection for the suppied interface
  Parameters:
    `interfaceType` - The interface
  Returns:
    ArrayList for List, TreeSet for SortedSet, HashSet for Set etc.

### findPropertyNameForValue

    public static java.lang.String findPropertyNameForValue(java.lang.Object target, java.lang.Object obj)

  Locates the name of a property for the given value on the target object using Groovy's meta APIs. Note that this method uses the reference so the incorrect result could be returned for two properties that refer to the same reference. Use with caution.
  Parameters:
    `target` - The target
    `obj` - The property value
  Returns:
    The property name or null

### getBooleanFromMap

    public static boolean getBooleanFromMap(java.lang.String key, java.util.Map map)

  Retrieves a boolean value from a Map for the given key
  Parameters:
    `key` - The key that references the boolean value
    `map` - The map to look in
  Returns:
    A boolean value which will be false if the map is null, the map doesn't contain the key or the value is false

### getClassName

    @Deprecated
    public static java.lang.String getClassName(java.lang.String logicalName, java.lang.String trailingName)

  Returns the class name for the given logical name and trailing name. For example "person" and "Controller" would evaluate to "PersonController"
  deprecated:
    Use GrailsNameUtils.getClassName instead.
  Parameters:
    `logicalName` - The logical name
    `trailingName` - The trailing name
  Returns:
    The class name

### getClassNameRepresentation

    @Deprecated
    public static java.lang.String getClassNameRepresentation(java.lang.String name)

  Returns the class name representation of the given name
  deprecated:
    Use GrailsNameUtils.getClassNameRepresentation instead.
  Parameters:
    `name` - The name to convert
  Returns:
    The property name representation

### getExpandoMetaClass

    @SuppressWarnings("rawtypes")
    public static groovy.lang.MetaClass getExpandoMetaClass(java.lang.Class clazz)

### getFieldValue

    public static java.lang.Object getFieldValue(java.lang.Object obj, java.lang.String name)

  Get the value of a declared field on an object
  Parameters:
    obj
    name
  Returns:
    The object value or null if there is no such field or access problems

### getGetterName

    public static java.lang.String getGetterName(java.lang.String propertyName)

  Calculate the name for a getter method to retrieve the specified property
  Parameters:
    propertyName
  Returns:
    The name for the getter method for this property, if it were to exist, i.e. getConstraints

### getLogicalName

    @SuppressWarnings("rawtypes")
    @Deprecated
    public static java.lang.String getLogicalName(java.lang.Class clazz, java.lang.String trailingName)

  Retrieves the logical class name of a Grails artifact given the Grails class and a specified trailing name
  deprecated:
    Use GrailsNameUtils.getLogicalName instead.
  Parameters:
    `clazz` - The class
    `trailingName` - The trailing name such as "Controller" or "TagLib"
  Returns:
    The logical class name

### getLogicalName

    @Deprecated
    public static java.lang.String getLogicalName(java.lang.String name, java.lang.String trailingName)

  Retrieves the logical name of the class without the trailing name
  deprecated:
    Use GrailsNameUtils.getLogicalName instead.
  Parameters:
    `name` - The name of the class
    `trailingName` - The trailing name
  Returns:
    The logical name

### getLogicalPropertyName

    @Deprecated
    public static java.lang.String getLogicalPropertyName(java.lang.String className, java.lang.String trailingName)

  deprecated:
    Use GrailsNameUtils.getLogicalPropertyName instead.

### getNameFromScript

    @Deprecated
    public static java.lang.String getNameFromScript(java.lang.String scriptName)

  Calculates the class name from a script name in the form my-funk-grails-script
  deprecated:
    Use GrailsNameUtils.getNameFromScript instead.
  Parameters:
    `scriptName` - The script name
  Returns:
    A class name

### getNaturalName

    @Deprecated
    public static java.lang.String getNaturalName(java.lang.String name)

  Converts a property name into its natural language equivalent eg ('firstName' becomes 'First Name')
  deprecated:
    Use GrailsNameUtils.getNaturalName instead.
  Parameters:
    `name` - The property name to convert
  Returns:
    The converted property name

### getPropertiesAssignableToType

    public static PropertyDescriptor[] getPropertiesAssignableToType(java.lang.Class clazz, java.lang.Class propertySuperType)

  Retrieves all the properties of the given class which are assignable to the given type
  Parameters:
    `clazz` - The class to retrieve the properties from
    `propertySuperType` - The type of the properties you wish to retrieve
  Returns:
    An array of PropertyDescriptor instances

### getPropertiesOfType

    public static PropertyDescriptor[] getPropertiesOfType(java.lang.Class clazz, java.lang.Class propertyType)

  Retrieves all the properties of the given class for the given type
  Parameters:
    `clazz` - The class to retrieve the properties from
    `propertyType` - The type of the properties you wish to retrieve
  Returns:
    An array of PropertyDescriptor instances

### getProperty

    public static java.beans.PropertyDescriptor getProperty(java.lang.Class clazz, java.lang.String propertyName, java.lang.Class propertyType)

  Retrieves a property of the given class of the specified name and type
  Parameters:
    `clazz` - The class to retrieve the property from
    `propertyName` - The name of the property
    `propertyType` - The type of the property
  Returns:
    A PropertyDescriptor instance or null if none exists

### getPropertyDescriptorForValue

    public static java.beans.PropertyDescriptor getPropertyDescriptorForValue(java.lang.Object instance, java.lang.Object propertyValue)

  Retrieves a PropertyDescriptor for the specified instance and property value
  Parameters:
    `instance` - The instance
    `propertyValue` - The value of the property
  Returns:
    The PropertyDescriptor

### getPropertyForGetter

    public static java.lang.String getPropertyForGetter(java.lang.String getterName)

  Returns a property name equivalent for the given getter name or null if it is not a getter
  Parameters:
    `getterName` - The getter name
  Returns:
    The property name equivalent

### getPropertyForSetter

    public static java.lang.String getPropertyForSetter(java.lang.String setterName)

  Returns a property name equivalent for the given setter name or null if it is not a getter
  Parameters:
    `setterName` - The setter name
  Returns:
    The property name equivalent

### getPropertyName

    @Deprecated
    public static java.lang.String getPropertyName(java.lang.String name)

  Shorter version of getPropertyNameRepresentation
  deprecated:
    Use GrailsNameUtils.getPropertyName instead.
  Parameters:
    `name` - The name to convert
  Returns:
    The property name version

### getPropertyName

    @SuppressWarnings("rawtypes")
    @Deprecated
    public static java.lang.String getPropertyName(java.lang.Class clazz)

  Shorter version of getPropertyNameRepresentation
  deprecated:
    Use GrailsNameUtils.getPropertyName instead.
  Parameters:
    `clazz` - The clazz to convert
  Returns:
    The property name version

### getPropertyNameForLowerCaseHyphenSeparatedName

    @Deprecated
    public static java.lang.String getPropertyNameForLowerCaseHyphenSeparatedName(java.lang.String name)

  Converts foo-bar into fooBar
  deprecated:
    Use GrailsNameUtils.getPropertyNameForLowerCaseHyphenSeparatedName instead.
  Parameters:
    `name` - The lower case hyphen separated name
  Returns:
    The property name equivalent

### getPropertyNameRepresentation

    @SuppressWarnings("rawtypes")
    @Deprecated
    public static java.lang.String getPropertyNameRepresentation(java.lang.Class targetClass)

  Returns the property name equivalent for the specified class
  deprecated:
    Use GrailsNameUtils.getPropertyNameRepresentation instead.
  Parameters:
    `targetClass` - The class to get the property name for
  Returns:
    A property name reperesentation of the class name (eg. MyClass becomes myClass)

### getPropertyNameRepresentation

    @Deprecated
    public static java.lang.String getPropertyNameRepresentation(java.lang.String name)

  Returns the property name representation of the given name
  deprecated:
    Use GrailsNameUtils.getPropertyNameRepresentation instead.
  Parameters:
    `name` - The name to convert
  Returns:
    The property name representation

### getPropertyOrStaticPropertyOrFieldValue

    public static java.lang.Object getPropertyOrStaticPropertyOrFieldValue(java.lang.Object obj, java.lang.String name)

  Looks for a property of the reference instance with a given name.

  If found its value is returned. We follow the Java bean conventions with augmentation for groovy support and static fields/properties. We will therefore match, in this order:

  1. Standard public bean property (with getter or just public field, using normal introspection)
  2. Public static property with getter method
  3. Public static field
  Returns:
    property value or null if no property found

### getPropertyType

    public static java.lang.Class getPropertyType(java.lang.Class clazz, java.lang.String propertyName)

  Returns the type of the given property contained within the specified class
  Parameters:
    `clazz` - The class which contains the property
    `propertyName` - The name of the property
  Returns:
    The property type or null if none exists

### getPropertyValueOfNewInstance

    @SuppressWarnings({ "unchecked", "rawtypes" })
    public static java.lang.Object getPropertyValueOfNewInstance(java.lang.Class clazz, java.lang.String propertyName, @SuppressWarnings("unused") java.lang.Class propertyType)

  Returns the value of the specified property and type from an instance of the specified Grails class
  Parameters:
    `clazz` - The name of the class which contains the property
    `propertyName` - The property name
    `propertyType` - The property type
  Returns:
    The value of the property or null if none exists

### getPropertyValueOfNewInstance

    public static java.lang.Object getPropertyValueOfNewInstance(java.lang.Class clazz, java.lang.String propertyName)

  Returns the value of the specified property and type from an instance of the specified Grails class
  Parameters:
    `clazz` - The name of the class which contains the property
    `propertyName` - The property name
  Returns:
    The value of the property or null if none exists

### getScriptName

    @SuppressWarnings("rawtypes")
    @Deprecated
    public static java.lang.String getScriptName(java.lang.Class clazz)

  Retrieves the script name representation of the supplied class. For example MyFunkyGrailsScript would be my-funky-grails-script
  deprecated:
    Use GrailsNameUtils.getScriptName instead.
  Parameters:
    `clazz` - The class to convert
  Returns:
    The script name representation

### getScriptName

    @Deprecated
    public static java.lang.String getScriptName(java.lang.String name)

  deprecated:
    Use GrailsNameUtils.getScriptName instead.

### getSetterName

    public static java.lang.String getSetterName(java.lang.String propertyName)

  Retrieves the name of a setter for the specified property name
  Parameters:
    `propertyName` - The property name
  Returns:
    The setter equivalent

### getShortName

    @SuppressWarnings("rawtypes")
    @Deprecated
    public static java.lang.String getShortName(java.lang.Class targetClass)

  Returns the class name without the package prefix
  deprecated:
    Use GrailsNameUtils.getShortName instead.
  Parameters:
    `targetClass` - The class to get a short name for
  Returns:
    The short name of the class

### getShortName

    @Deprecated
    public static java.lang.String getShortName(java.lang.String className)

  Returns the class name without the package prefix
  deprecated:
    Use GrailsNameUtils.getShortName instead.
  Parameters:
    `className` - The class name to get a short name for
  Returns:
    The short name of the class

### getStaticPropertyValue

    public static java.lang.Object getStaticPropertyValue(java.lang.Class clazz, java.lang.String name)

  Get a static property value, which has a public static getter or is just a public static field.

  Parameters:
    `clazz` - The class to check for static property
    `name` - The property name
  Returns:
    The value if there is one, or null if unset OR there is no such property

### isAssignableOrConvertibleFrom

    public static boolean isAssignableOrConvertibleFrom(java.lang.Class clazz, java.lang.Class type)

  Returns true if the specified clazz parameter is either the same as, or is a superclass or superinterface of, the specified type parameter. Converts primitive types to compatible class automatically.
  Parameters:
    clazz
    type
  Returns:
    True if the class is a taglib
  See Also:
    java.lang.Class#isAssignableFrom(Class)

### isClassBelowPackage

    public static boolean isClassBelowPackage(java.lang.Class theClass, java.util.List packageList)

  Returns whether the specified class is either within one of the specified packages or within a subpackage of one of the packages
  Parameters:
    `theClass` - The class
    `packageList` - The list of packages
  Returns:
    True if it is within the list of specified packages

### isGetter

    public static boolean isGetter(java.lang.String name, Class[] args)

  Returns true if the name of the method specified and the number of arguments make it a javabean property
  Parameters:
    `name` - True if its a Javabean property
    `args` - The arguments
  Returns:
    True if it is a javabean property method

### isGroovyAssignableFrom

    public static boolean isGroovyAssignableFrom(java.lang.Class leftType, java.lang.Class rightType)

  Tests whether or not the left hand type is compatible with the right hand type in Groovy terms, i.e. can the left type be assigned a value of the right hand type in Groovy.

  This handles Java primitive type equivalence and uses isAssignableFrom for all other types, with a bit of magic for native types and polymorphism i.e. Number assigned an int. If either parameter is null an exception is thrown

  Parameters:
    `leftType` - The type of the left hand part of a notional assignment
    `rightType` - The type of the right hand part of a notional assignment
  Returns:
    True if values of the right hand type can be assigned in Groovy to variables of the left hand type.

### isJdk5Enum

    public static boolean isJdk5Enum(java.lang.Class type)

  Checks whether the given class is a JDK 1.5 enum or not
  Parameters:
    `type` - The class to check
  Returns:
    True if it is an enum

### isMatchBetweenPrimativeAndWrapperTypes

    @SuppressWarnings("rawtypes")
    public static boolean isMatchBetweenPrimativeAndWrapperTypes(java.lang.Class leftType, java.lang.Class rightType)

  Detect if left and right types are matching types. In particular, test if one is a primitive type and the other is the corresponding Java wrapper type. Primitive and wrapper classes may be passed to either arguments.
  Parameters:
    leftType
    rightType
  Returns:
    true if one of the classes is a native type and the other the object representation of the same native type

### isPropertyInherited

    @SuppressWarnings("rawtypes")
    public static boolean isPropertyInherited(java.lang.Class clz, java.lang.String propertyName)

  Checks whether the specified property is inherited from a super class
  Parameters:
    `clz` - The class to check
    `propertyName` - The property name
  Returns:
    True if the property is inherited

### isPropertyOfType

    public static boolean isPropertyOfType(java.lang.Class clazz, java.lang.String propertyName, java.lang.Class type)

  Returns true if the specified property in the specified class is of the specified type
  Parameters:
    `clazz` - The class which contains the property
    `propertyName` - The property name
    `type` - The type to check
  Returns:
    A boolean value

### isPublicField

    public static boolean isPublicField(java.lang.Object obj, java.lang.String name)

  Work out if the specified object has a public field with the name supplied.
  Parameters:
    obj
    name
  Returns:
    True if a public field with the name exists

### isPublicStatic

    public static boolean isPublicStatic(java.lang.reflect.Method m)

  Determine whether the method is declared public static
  Parameters:
    m
  Returns:
    True if the method is declared public static

### isPublicStatic

    public static boolean isPublicStatic(java.lang.reflect.Field f)

  Determine whether the field is declared public static
  Parameters:
    f
  Returns:
    True if the field is declared public static

### isSetter

    @SuppressWarnings("rawtypes")
    public static boolean isSetter(java.lang.String name, Class[] args)

### isStaticProperty

    @SuppressWarnings("rawtypes")
    public static boolean isStaticProperty(java.lang.Class clazz, java.lang.String propertyName)

  Work out if the specified property is readable and static. Java introspection does not recognize this concept of static properties but Groovy does. We also consider public static fields as static properties with no getters/setters

  Parameters:
    `clazz` - The class to check for static property
    `propertyName` - The property name
  Returns:
    true if the property with name propertyName has a static getter method

Groovy Documentation